#!/usr/bin/perl

require "setup.cgi";

$PageTitle  = "Uploader";

#Diese Pfade und URL anpassen
#$UploadPath = "/homepages/1/pfad/htdocs/filebase";
#$ScriptURL  = "http://www.ihredomain.de/cgi-bin/filebase/upp.cgi";
#$SiteURL    = "http://www.ihredomain.de/filebase";

# Der Pfad zu Ihrem Mailprogramm
#$mailprog = '/usr/sbin/sendmail';

# Webmaster E-Mail
#$adminemail = "webmaster\@ihredomain.de";

# Pfad zur LogDatei
#$LogFile    = "/homepages/1/pfad/htdocs/filebase/logfile.txt";

#$MaxSize = "100";    # Maximale Uploadgre in KB, freilassen fr keine Begrenzung

# Erlaubte Dateien
# Nach dem Schema eintragen:  @Exts = qw(jpg gif html htm);
# Keine Kommas oder dergl. dazwischen!
#@Exts = qw(zip jpg gif txt);     

# berschreiben der Dateien erlauben? 0=NEIN 1=JA                 
#$AllowRewrite = "0"; 

# Nichts weiter ndern ab hier
###################################################################################


use File::stat;
use CGI qw(:standard);


$Action = param('action');
$Query  = $ENV{'QUERY_STRING'};

if ($Action eq "upload") {
    &Upload;
    if ($LogFile) {
        $CurDate = &GetDateAndTime;
        &LogIt($CurDate);
    }
    exit;
}
elsif ($Query eq "viewlog") {
    &ViewLog;
}

sub ViewLog {
    if (!$LogFile) {
        &error("Logging ist nicht aktiviert.");
    }
    elsif (! -e "$LogFile") {
        open(LOG,">$LogFile") or &error("cant create log! $!");
        close(LOG);
    }
    

print header;
print qq~
<html>
 <head>
  <title>Logdateien:</title>
<style type="text/css">   
   <!--
   a:aktive  {
   	font-family : Verdana, Arial;
   	font-size : 9pt;
   	color : blue;
   	font-weight : normal;
   	text-decoration : none;line-height :12pt;
   }
   
   a:hover  {
   	font-family : Verdana, Arial;
   	font-size : 9pt;
   	color : Red;
   	text-decoration : underline;line-height :12pt;
   }
   
   body  {
   	font-family : Verdana, Arial;
   	font-size : 10pt;
   	color : blue;line-height :12pt;
   }
   
   a  {
   	font-family : Verdana, Arial;
   	font-size : 9pt;
   	color : Blue;
   	text-decoration : none;line-height :12pt;
   }
   
    td,table  {
   	font-family : Verdana, Arial;
   	font-size : 9pt;
   	color : black;line-height :12pt;
   	

   -->
   </style>

 </head>
 <body bgcolor="#ffffff">
 &nbsp;<P>
 
 <Center><font size="3" face="arial" color="red">Logdateien: $PageTitle<P>
 
 <table border=0 width=90% cellpadding=2 cellspacing=2>
  <tr>
   <td>
   
 <font size="2" face="Verdana" color="black">Hier die Upload Logstatistik.<P>
 
 <table border=1 cellpadding=1 cellspacing=1 width=100%>
  <tr>
   <td colspan=2><B><font size=2 face=verdana>Dateiname</td>
   <td colspan=2><B><font size=2 face=verdana>Uploader Name</td>
   <td colspan=2><B><font size=2 face=verdana>Datum</td>
   <td colspan=2><B><font size=2 face=verdana>IP Nummer</td>
  </tr>~;   
     
    open(LOG,"$LogFile") or &error("cant open log! $!");
    while (<LOG>) {
        push(@ENTRIES,$_);
    }
    close(LOG);
    
    foreach $Entry (@ENTRIES) {
        local($Date,$File,$IP) = split(/<!-NEXT-!>/, $Entry);
        print qq~
$Date $File $IP
~;
    }
    
     print qq~
     </table> 
     </td>
     </tr>
    </table><P>
    
     </body>
     </html>~;
     exit;
}

sub LogIt {

    my $Date = shift;
    my $FileName = $FileOnly;
open (FILE, ">>$LogFile");
print FILE "<tr>";                          
print FILE "<td><b>Dateiname:</b></td><td><a href=\"$SiteURL/$FileName\">$FileName</a></td><td><b>Name Uploader:</b></td><td>$Username</td><td><b>Datum:</b></td><td>$Date</td><td><b>IP-Nummer:</b></td><td> $ENV{'REMOTE_ADDR'}</td>";
print FILE "</tr>\n";
close(FILE);



}

sub Upload {


    $FileOnly = param('towhere');
    $File2 = param('whichfile');
    $NewFile = "$UploadPath/$FileOnly";
    $MaxSizeBytes =1024 * $MaxSize;
    $Username = param('Username');
    if (@Exts) {
        foreach $Ext (@Exts) {
            if (grep /$Ext$/i, $NewFile) {
                $ok = 1;
            }
        }
    }
    else {
        $ok = 1;
    }
 
    if ($ok == 1) {
      if (!-e "$NewFile" or $AllowRewrite == "1") {
        
        open(OUTFILE, ">$NewFile") or &error("cant create new file of this name! $!");
        binmode OUTFILE;
        while ($bytesread=read($File2,$buffer,1024)) {
            print OUTFILE $buffer;
        }
        close (OUTFILE);
        
        if ($MaxSize) {
	    $inode = stat($NewFile);
	    $Size = $inode->size;

            if ($Size > $MaxSizeBytes) {
                
                unlink "$NewFile" or &error("cant unlink $NewFile, zu gro; $!");
                &error("Ihre Datei ist zu gro!");
            }
        }
      }
      else {
          &error("Diese Datei existiert schon auf dem Server, bitte anderen Dateiname whlen.");
      }
    }
    else {
        &error("Unerlaubter Dateityp.");
    }

print header;

print qq~
<html>
 <head>
  <title>Upload</title>
 </head>
 <body bgcolor="#ffffff">
 &nbsp;<P>
 
 <Center><font size="3" face="arial">Dateiupload</font><P>
 
 <table border=0 width=75% cellpadding=2 cellspacing=2>
  <tr>
   <td>
   
 <font size="2" face="Verdana" color="black">Ihre Datei wurde hochgeladen nach:<P>
 
Absoluter Pfad: <B>$NewFile</B><P>
 
Dateiname: <B>~, param('towhere'), qq~</B><P>
 
URL: <B>$SiteURL/~, param('towhere'), qq~</B><P>

URL-Link: <B><a href=\"$SiteURL/$FileOnly\" target=\"new\">$SiteURL/$FileOnly</a></B><br>
Kopieren Sie nun diese URL in das Feld wo die Dateiurl angegeben werden muss.
<P>
 
 </td>
 </tr>
</table>

 </body>
</html>~;

#open (MAIL, "|$mailprog -t") || die $!;
#print MAIL "To: $adminemail\n";
#print MAIL "From: $adminemail\n";
#print MAIL "Subject: Neue Datei hochgeladen\n";
#print MAIL "Es wurde eine neue Datei hochgeladen, hier die Infos dazu:\n\n";
#print MAIL "Absoluter Pfad: $NewFile\n";
#print MAIL "Dateiname: $FileOnly\n";
#print MAIL "URL: $SiteURL/$FileOnly\n\n";

#close(MAIL);

}

print header;

print qq~
<html>
 <head>
  <title> Upload</title>
  <Script Language="JavaScript">
  function checkvalues() {
      if (document.form.whichfile.value == "") {
          alert("Bitte whlen Sie eine Datei von Ihrem Computer!");
          document.form.whichfile.focus();
      }
      else if (document.form.towhere.value == "") {
          alert("Bitte geben Sie einen Dateinamen ein fr die Datei die hochgeladen werden soll.");
          document.form.towhere.focus();
      }
      else {
          document.form.submit();
      }
  }
  </script>
 </head>
 <body bgcolor="#FFFFFF">
 &nbsp;<P>
 
 <Center><font size="3" face="verdana,arial" color="navy">Dateiupload</font><P>
 
 <table border=0 width=75% cellpadding=2 cellspacing=2>
  <tr>
   <td>
   
 <font size="2" face="Verdana" color="black">Um eine Datei hochzuladen klicken Sie zunchst auf 
den <b>Durchsuchen</b> Button um eine Datei auf Ihrem Computer auszuwhlen. Dann geben Sie einen Dateinamen fr die Datei ein.<P>
 
 <B><u><font color="blue">Hier die Uploadregeln:</b></u></font><P>
 
  <ul>\n~;
 
if (@Exts) {
    print qq~<li>Erlaubte Dateitypen sind: <b>.~, join(', .', @Exts), qq~</b>\n~;
}
else {
    print qq~<li>Alle Dateiarten erlaubt.\n~;
}

if ($MaxSize) {
    print qq~<li>Uploads drfen max. <B>$MaxSize</B> Kbytes gro sein.\n~;
}
else {
    print qq~<li>Uploads jeder Dateigre gestattet.\n~;
}

if ($LogFile) {
    print qq~<li>Alle Uploads werden geloggt.  Logdatei ansehen <A href="$ScriptURL?viewlog">hier</a>.\n~;
}
else {
    print qq~<li>Uploads werden <b>nicht</b> geloggt.\n~;
}

print qq~
</ul><P>

  <center>
 <form method=post action="$ScriptURL" enctype="multipart/form-data" name=form>
 <input type=hidden name=action value="upload">
<table bgcolor="#000080" width="550" cellspacing="1" cellpadding="0" border="0">
<tr>
    <td>
	<table bgcolor="#EFEFEF" width="550" cellspacing="0" cellpadding="3" border="0">
<tr>
    <td align="right"><font face="Verdana, Arial" size="1">Ihr Name</font></td>
    <td><input type=text name=Username" size=20></td>
</tr>
<tr>
    <td align="right"><font face="Verdana, Arial" size="1">Datei auswhlen</font></td>
    <td><input type=file name="whichfile" size=20></td>
</tr>
<tr>
    <td align="right"><font face="Verdana, Arial" size="1">Dateiname nach Upload (Dateiendung mit angeben, (z.B.: meinbild.jpg):</font></td>
    <td><input type=text name="towhere" size=30></td>
</tr>
<tr>
    <tr>
    <td colspan="2" align="center"><input type=button onClick="checkvalues()" value="Upload Datei" width=200 style="width:200"> <input type=reset></td>
    
</tr>
    
</tr>
</table></td>
</tr>
</table>
</form>
</center>
 
 </td>
 </tr>
</table>

 </body>
</html>~;


sub GetDateAndTime {
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    $min = "0$min" if ($min < 10);
    $mon = "0$mon" if ($mon < 10);
    $mday = "0$mday" if ($mday < 10);

    $month = ($mon + 1);
    
    @months = ("Januar","Februar","Maerz","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");
    @days = ("Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag");


    
    $year += 1900;
    chomp($date);
    
    return "/$mday/$month/$year um $hour:$min";
}

sub error {
    my $err = shift;

print header;
print qq~
<html>
 <head>
  <title> Error </title>
 </head>
 <body bgcolor="#FFFFFF">
 &nbsp;<P>
 
 <Center><font size="3" face="arial" color="red">FEHLER<P>
 
 <table border=0 width=75% cellpadding=2 cellspacing=2>
  <tr>
   <td>
   
 <font size="2" face="Verdana" color="black">Es sind Fehler aufgetreten: <B>$err</B><P>
 
 </td>
 </tr>
</table>

 </body>
</html>~;
    exit;
}
